/***************************************************************************
                          setup.h  -  description
                             -------------------
    begin                : mar jul 29 2003
    copyright            : (C) 2003 by Jaime Robles
    email                : jaime@kde.org
 ***************************************************************************/

/******************************************************************************
 *                                                                            *
 *   This program is free software; you can redistribute it and/or modify     *
*  it under the terms of the GNU General Public License as published by     *
*  the Free Software Foundation; either version 2 of the License, or        *
*  (at your option) any later version.                                      *
 *                                                                            *
*  This program is distributed in the hope that it will be useful,          *
*  but WITHOUT ANY WARRANTY; without even the implied warranty of           *
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the            *
*  GNU General Public License for more details.                             *
 *                                                                            *
*  You should have received a copy of the GNU General Public License        *
*  along with this program; if not, write to the Free Software              *
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA*
 *****************************************************************************/ 

#ifndef SETUP_H
#define SETUP_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif
#include <qwidget.h>
#include <qfile.h>
#include <qfiledialog.h>
#include <kcombobox.h>
#include <qdir.h>
#include <qcheckbox.h>
#include <klineedit.h>
#include <knuminput.h>
#include <kcolorcombo.h>
#include <kpushbutton.h>
#include "kloghamlib.h"
#include "setupui.h"
#include "kloghamlib.h"
//#include "hamlib/rig.h"

//#include "ostream.h"


class Setup : public setupui{
  Q_OBJECT
  public:
    /** construtor */
    Setup(QWidget* parent=0, const char *name=0);
    /** destructor */
    ~Setup();

  public:
  
  public slots:
  void setRig();

  private slots:
  void slotOkBtnClicked();
  void slotFileNameClicked();
  void slotOpenFileButtonClicked();
  private:
  void readConf();
  void writeConf();
  bool dirExist;
  QString fileName;
  QString klogDir;
  QColor color;
  int power;
//  confirmedkColorCombo
//  workedkColorCombo
//  neededkColorCombo
  static int addRigToList(const struct rig_caps* caps, void* data);
  QMap<QString, rig_model_t> rigname2rigid;
  QMap<rig_model_t, QString> rigid2rigname;
  QStringList strings;

};

#endif
